% Get property from the specified object and return the value.
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string,
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
if (nargin == 1)
    val = {{{'conductivity'}, {'conductivity matrix, [d,d], where d=1, 2, or 3'}};...
        {{'specific_heat'}, {'specific heat, scalar'}};...
        {{'rho'}, {'mass density, scalar'}};...
        {{'source'}, {'heat source, either scalar or function handle'}}};
    return;
else
    prop_name=varargin{1};
    switch prop_name
        case 'conductivity'
            val = self.conductivity;
        case 'specific_heat'
            val = self.specific_heat;
        case 'rho'
            val = self.rho;
        case 'source'
            val = self.source;
        otherwise
            val = get(self.mater, prop_name);
    end
end
